﻿using System;

namespace ParkingLot_Plain.Parkoviste
{
    public class ParkovisteZbyvaEvent
    {
        public delegate void EventHandler(Object source, int volnaMista);

        private static volatile ParkovisteZbyvaEvent _instance;
        private static readonly object SyncRoot = new Object();

        private ParkovisteZbyvaEvent()
        {
        }

        public int VolnaMista { get; private set; }

        public static ParkovisteZbyvaEvent Instance
        {
            get
            {
                if (_instance != null) return _instance;

                lock (SyncRoot)
                {
                    if (_instance == null)
                        _instance = new ParkovisteZbyvaEvent();
                }

                return _instance;
            }
        }

        public event EventHandler Event;

        public void PublishZbyvaEvent(Object source, int volnaMista)
        {
            VolnaMista = volnaMista;
            if (Event != null)
            {
                Event(source, volnaMista);
            }
        }
    }
}