﻿using System;
using System.Threading;
using ParkingLot_Plain.Interfaces;
using ParkingLot_Plain.Parkoviste;

namespace ParkingLot_Plain.Pult
{
    internal class Pult
    {
        private IZapVyp _brana;
        private IPrijeloOdjelo _statistika;
        private IZapVyp _tabule;

        public Pult()
        {
            Subscribe();
        }

        public IZapVyp Tabule
        {
            set { _tabule = value; }
        }

        public IZapVyp Brana
        {
            set { _brana = value; }
        }

        public IPrijeloOdjelo Statistika
        {
            set { _statistika = value; }
        }

        public int PracovniDoba { get; set; }

        public void Subscribe()
        {
            ParkovisteZbyvaEvent.Instance.Event += ParkovisteZbyvaEventHandling;
            ParkovistePlneEvent.Instance.Event += ParkovistePlneEventHandling;
        }

        private static void ParkovisteZbyvaEventHandling(Object source, int volnaMista)
        {
            Console.Out.WriteLine("(Pult) Volna mista: " + volnaMista);
        }

        private static void ParkovistePlneEventHandling(Object source)
        {
            Console.Out.WriteLine("(Pult) Parkoviste je plne!");
        }

        public void Zacatek()
        {
            Console.Out.WriteLine("Pracovni doba zacala, spoustim tabuli a branu...");
            _tabule.Zap();
            _brana.Zap();
        }

        public void Konec()
        {
            Console.Out.WriteLine("Pracovni doba konci, vypinam tabuli a branu...");
            _tabule.Vyp();
            _brana.Vyp();
            Console.Out.WriteLine("Na parkovisti zustalo: " + (_statistika.GetPrijelo() - _statistika.GetOdjelo()) +
                                  " vozidel...");
        }

        public static void OpakujPracovniDobu(Pult pult)
        {
            while (true)
            {
                pult.Zacatek();
                try
                {
                    Thread.Sleep(pult.PracovniDoba);
                }
                catch (Exception e)
                {
                    Console.Out.WriteLine(e);
                }
                pult.Konec();
            }
        }
    }
}